package de.fhmuenster.masterthesis.formatting2;

import com.google.common.base.Objects;
import com.google.inject.Inject;
import de.fhmuenster.masterthesis.services.TestgeneratorDSLGrammarAccess;
import de.fhmuenster.masterthesis.testgeneratorDSL.BPMNDiagram;
import de.fhmuenster.masterthesis.testgeneratorDSL.BooleanVariable;
import de.fhmuenster.masterthesis.testgeneratorDSL.Declaration;
import de.fhmuenster.masterthesis.testgeneratorDSL.EndChecks;
import de.fhmuenster.masterthesis.testgeneratorDSL.ExternalServiceMock;
import de.fhmuenster.masterthesis.testgeneratorDSL.ExternalTopic;
import de.fhmuenster.masterthesis.testgeneratorDSL.Flow;
import de.fhmuenster.masterthesis.testgeneratorDSL.FlowElement;
import de.fhmuenster.masterthesis.testgeneratorDSL.IntVariable;
import de.fhmuenster.masterthesis.testgeneratorDSL.Loop;
import de.fhmuenster.masterthesis.testgeneratorDSL.Mock;
import de.fhmuenster.masterthesis.testgeneratorDSL.MockingRule;
import de.fhmuenster.masterthesis.testgeneratorDSL.Model;
import de.fhmuenster.masterthesis.testgeneratorDSL.StringVariable;
import de.fhmuenster.masterthesis.testgeneratorDSL.Test;
import de.fhmuenster.masterthesis.testgeneratorDSL.Variable;
import de.fhmuenster.masterthesis.testgeneratorDSL.VariableDeclarations;
import java.util.Arrays;
import java.util.List;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.formatting2.AbstractFormatter2;
import org.eclipse.xtext.formatting2.IFormattableDocument;
import org.eclipse.xtext.formatting2.IHiddenRegionFormatter;
import org.eclipse.xtext.resource.XtextResource;
import org.eclipse.xtext.xbase.lib.Extension;
import org.eclipse.xtext.xbase.lib.Procedures.Procedure1;

@SuppressWarnings("all")
public class TestgeneratorDSLFormatter extends AbstractFormatter2 {
  @Inject
  @Extension
  private TestgeneratorDSLGrammarAccess _testgeneratorDSLGrammarAccess;
  
  protected void _format(final Model model, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.newLine();
      it.oneSpace();
    };
    document.prepend(this.textRegionExtensions.regionFor(model).keyword("with"), _function);
    final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
      it.noSpace();
    };
    document.prepend(this.textRegionExtensions.regionFor(model).keyword(";"), _function_1);
    final Procedure1<IHiddenRegionFormatter> _function_2 = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.<Model>append(model, _function_2);
    List<Declaration> declarationsList = model.getDeclarations();
    int decCount = 0;
    int maxDecCount = declarationsList.size();
    for (final Declaration declarations : declarationsList) {
      {
        document.<Declaration>format(declarations);
        if ((decCount < (maxDecCount - 1))) {
          FormattingType formattingType = this.getFormattingType(declarations);
          FormattingType nextFormattingType = this.getFormattingType(declarationsList.get((decCount + 1)));
          boolean _shouldSeparateDouble = this.shouldSeparateDouble(formattingType, nextFormattingType);
          if (_shouldSeparateDouble) {
            final Procedure1<IHiddenRegionFormatter> _function_3 = (IHiddenRegionFormatter it) -> {
              it.setNewLines(2);
            };
            document.<Declaration>append(declarations, _function_3);
          } else {
            final Procedure1<IHiddenRegionFormatter> _function_4 = (IHiddenRegionFormatter it) -> {
              it.newLine();
            };
            document.<Declaration>append(declarations, _function_4);
          }
        }
        decCount++;
      }
    }
  }
  
  protected void _format(final BPMNDiagram diagram, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(diagram).keyword("with"), _function);
  }
  
  protected void _format(final Loop loop, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(loop).keyword("starts"), _function);
    final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(loop).keyword("follows"), _function_1);
    final Procedure1<IHiddenRegionFormatter> _function_2 = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(loop).keyword("ends"), _function_2);
    final Procedure1<IHiddenRegionFormatter> _function_3 = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(loop).keyword("has"), _function_3);
  }
  
  protected void _format(final Flow flow, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(flow).keyword("with"), _function);
    final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(flow).keyword("without"), _function_1);
  }
  
  protected void _format(final FlowElement flowElement, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.noSpace();
    };
    document.prepend(this.textRegionExtensions.regionFor(flowElement).keyword(":"), _function);
    final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
      it.noSpace();
    };
    document.prepend(this.textRegionExtensions.regionFor(flowElement).keyword(";"), _function_1);
  }
  
  protected void _format(final ExternalTopic externalTopic, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.noSpace();
    };
    document.prepend(this.textRegionExtensions.regionFor(externalTopic).keyword(";"), _function);
  }
  
  protected void _format(final StringVariable stringVariable, @Extension final IFormattableDocument document) {
  }
  
  protected void _format(final IntVariable integerVariable, @Extension final IFormattableDocument document) {
  }
  
  protected void _format(final BooleanVariable booleanVariable, @Extension final IFormattableDocument document) {
  }
  
  protected void _format(final ExternalServiceMock mock, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(mock).keyword("with"), _function);
    EList<MockingRule> _mockingRules = mock.getMockingRules();
    for (final MockingRule rule : _mockingRules) {
      {
        document.<MockingRule>format(rule);
        final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
          it.newLine();
        };
        document.<MockingRule>prepend(rule, _function_1);
      }
    }
  }
  
  protected void _format(final MockingRule rule, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.oneSpace();
    };
    document.prepend(this.textRegionExtensions.regionFor(rule).keyword("with"), _function);
  }
  
  protected void _format(final Test test, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.newLine();
    };
    document.prepend(this.textRegionExtensions.regionFor(test).keyword("with"), _function);
    EList<VariableDeclarations> _declarations = test.getDeclarations();
    for (final VariableDeclarations declarations : _declarations) {
      {
        document.<VariableDeclarations>format(declarations);
        final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
          it.newLine();
        };
        document.<VariableDeclarations>prepend(declarations, _function_1);
      }
    }
    EndChecks _endCheck = test.getEndCheck();
    boolean _notEquals = (!Objects.equal(_endCheck, null));
    if (_notEquals) {
      final Procedure1<IHiddenRegionFormatter> _function_1 = (IHiddenRegionFormatter it) -> {
        it.newLine();
      };
      document.<EndChecks>prepend(test.getEndCheck(), _function_1);
    }
  }
  
  protected void _format(final VariableDeclarations variableDeclarations, @Extension final IFormattableDocument document) {
    final Procedure1<IHiddenRegionFormatter> _function = (IHiddenRegionFormatter it) -> {
      it.oneSpace();
    };
    document.prepend(this.textRegionExtensions.regionFor(variableDeclarations).keyword("with"), _function);
  }
  
  public FormattingType getFormattingType(final Declaration declarations) {
    if ((declarations instanceof BPMNDiagram)) {
      return FormattingType.PROCESS;
    }
    if ((declarations instanceof Loop)) {
      return FormattingType.LOOP;
    }
    if ((declarations instanceof Flow)) {
      return FormattingType.FLOW;
    }
    if ((declarations instanceof FlowElement)) {
      return FormattingType.FLOW_ELEMENT;
    }
    if ((declarations instanceof Variable)) {
      return FormattingType.VARIABLE;
    }
    if ((declarations instanceof Mock)) {
      return FormattingType.MOCK;
    }
    if ((declarations instanceof Test)) {
      return FormattingType.TEST;
    }
    if ((declarations instanceof ExternalTopic)) {
      return FormattingType.EXTERNAL_TOPIC;
    }
    return null;
  }
  
  public boolean shouldSeparateDouble(final FormattingType first, final FormattingType second) {
    boolean _equals = first.equals(second);
    boolean _not = (!_equals);
    if (_not) {
      return true;
    }
    if ((first.equals(FormattingType.TEST) || first.equals(FormattingType.MOCK))) {
      return true;
    }
    return false;
  }
  
  public void format(final Object booleanVariable, final IFormattableDocument document) {
    if (booleanVariable instanceof BooleanVariable) {
      _format((BooleanVariable)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof ExternalServiceMock) {
      _format((ExternalServiceMock)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof IntVariable) {
      _format((IntVariable)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof StringVariable) {
      _format((StringVariable)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof XtextResource) {
      _format((XtextResource)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof BPMNDiagram) {
      _format((BPMNDiagram)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof ExternalTopic) {
      _format((ExternalTopic)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof Flow) {
      _format((Flow)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof FlowElement) {
      _format((FlowElement)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof Loop) {
      _format((Loop)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof Test) {
      _format((Test)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof MockingRule) {
      _format((MockingRule)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof Model) {
      _format((Model)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof VariableDeclarations) {
      _format((VariableDeclarations)booleanVariable, document);
      return;
    } else if (booleanVariable instanceof EObject) {
      _format((EObject)booleanVariable, document);
      return;
    } else if (booleanVariable == null) {
      _format((Void)null, document);
      return;
    } else if (booleanVariable != null) {
      _format(booleanVariable, document);
      return;
    } else {
      throw new IllegalArgumentException("Unhandled parameter types: " +
        Arrays.<Object>asList(booleanVariable, document).toString());
    }
  }
}
